/* --------------------------- grh.h ---------------------------------------- */

#ifndef _GR_INCLUDED
#define _GR_INCLUDED

/* FCALL
 *  0 no fascall support
 * 10 use 'fastcall'
 * 20 use '_fastcall'
 * 30 use '__fastcall'
 * add '1' if fascall is compatible with microsoft rules (11 21 31).
 *
 *
*/

#if FCALL >= 30
#define FASTCALL	__fastcall
#elif FCALL >= 20
#define FASTCALL	_fastcall
#elif FCALL >= 10
#define FASTCALL	fastcall
#else
#define FASTCALL
#endif

#if (FCALL%10) == 1
#define AFASTCALL	FASTCALL
#else
#define AFASTCALL
#endif

typedef unsigned char	uchar;
typedef unsigned short	ushort;
typedef unsigned int	uint;
typedef unsigned long	ulong;

#define MY_OFF(p)	(((ushort far *)&(p))[0])
#define MY_SEG(p)	(((ushort far *)&(p))[1])

typedef struct {
	uint	ax;
	uint	bx;
	uint	cx;
	uint	dx;
	uint	si;
	uint	di;
	uint	bp;
	uint	f;
	uint	ds;
	uint	es;
} REGISTERS;

struct ModeInfo {
	short   ModeAttributes;         /* Mode attributes                  */
	char    WinAAttributes;         /* Window A attributes              */
	char    WinBAttributes;         /* Window B attributes              */
	short   WinGranularity;         /* Window granularity in k          */
	short   WinSize;                /* Window size in k                 */
	short   WinASegment;            /* Window A segment                 */
	short   WinBSegment;            /* Window B segment                 */
	void    far *WinFuncPtr;        /* Pointer to window function       */
	short   BytesPerScanLine;       /* Bytes per scanline               */
	short   XResolution;            /* Horizontal resolution            */
	short   YResolution;            /* Vertical resolution              */
	char    XCharSize;              /* Character cell width             */
	char    YCharSize;              /* Character cell height            */
	char    NumberOfPlanes;         /* Number of memory planes          */
	char    BitsPerPixel;           /* Bits per pixel                   */
	char    NumberOfBanks;          /* Number of CGA style banks        */
	char    MemoryModel;            /* Memory model type                */
	char    BankSize;               /* Size of CGA style banks          */
	char    NumberOfImagePages;     /* Number of images pages           */
	char    res1;                   /* Reserved                         */
	char    RedMaskSize;            /* Size of direct color red mask    */
	char    RedFieldPosition;       /* Bit posn of lsb of red mask      */
	char    GreenMaskSize;          /* Size of direct color green mask  */
	char    GreenFieldPosition;     /* Bit posn of lsb of green mask    */
	char    BlueMaskSize;           /* Size of direct color blue mask   */
	char    BlueFieldPosition;      /* Bit posn of lsb of blue mask     */
	char    RsvdMaskSize;           /* Size of direct color res mask    */
	char    RsvdFieldPosition;      /* Bit posn of lsb of res mask      */
	char    DirectColorModeInfo;    /* Direct color mode attributes     */
	char    res2[216];              /* Pad to 256 byte block size       */
};

extern int far	int10 (REGISTERS *regs);
extern void far FASTCALL _GrSetPage (int pread, int pwrite);
extern uint far FASTCALL _GrGetPage (void);
extern uchar far * far FASTCALL _GrNewPage (ulong xy);

extern uint	near _ReadPage;
extern uint	near _WritePage;
extern uint	near _GrType;
extern uint	near _GrSizeX;
extern uint	near _GrSizeY;
extern uint	near _GrWriteMode;
extern uint	near _GrBiosMode;
extern ulong	near _BankSwitches;
extern long	near _ActiveBase;

extern uint	far divtab[2048];

extern void	far _SetPG (uint page);
extern int	far _SetVS (ulong base);
extern void	far _SetCH (uint ctype, uint nbanks, uint width);
extern uchar far * far FASTCALL _GrAddrC (uint x, uint y);
extern int	far AFASTCALL _muldiv (int x, int y, int z);

#ifdef USE_ASM
extern void	far vgaput (uint at, uchar far *f, int n);
extern void	far vgaget (uchar far *t, uint af, int n);
extern void	far vgamov (uint at, uint af, int n);
extern void	far vgaset (uint at, int c, int w);
extern void	far _SetWM (uint mode);
extern uchar far * far AFASTCALL _GrAddr  (uint x, uint y);
#else	/* ifdef USE_ASM */
#define _SetWM(mode)
#endif	/* else ifdef USE_ASM */

#include "gr.h"

#endif
